;     1-wire
;     DS1820
; - AtTiny15
; - omercury
;  - 25.1o.21o
;*********************************************
.include "tn15def.inc"
.device ATtiny15
;**********  Variables  ************* 
.include "w1_tn15_var.asm"
;********  End Variables  ***********
.CSEG
.org 0
	rjmp	begin					;
	reti	;rjmp	Ext_INT0				; External Interrupt Request 0
	reti	;rjmp	PCI				; Pin Change Interrupt
	reti	;rjmp	Tim1_CompA		; Timer/Counter1 Compare Match A
	reti	;rjmp	Tim1_OVF		; Timer/Counter1 Overflow
	reti	;rjmp	Tim0_OVF		; Timer/Counter0 Overflow
	reti	;rjmp	EERDY			; EEPROM Ready
	reti	;rjmp	ACE				; Analog Comparator Event
	reti	;rjmp	ADC_Comp		; ADC Conversion Complete
;********************************************************************************
;	INT_VECTORS_SIZE	= 9	; size in words
;********************************************************************************
.include "1-wire_tn15.asm"
;********************************************************************************
begin:		; 
	ldi		temp,(1<<dout)+(1<<clk)		; OVER  PWM  
	out		DDRB,temp					;
	ser		temp						;   "1"
	out		PORTB,temp

start:

rcall	OWReset

ldi		w1rdbuf,$CC
rcall	OWWriteByte

ldi		w1rdbuf,$44
rcall	OWWriteByte

	ldi		r17,255		;    
delay650:
	ldi		w1del,255	;2,55 (2550us)
	rcall	Del_10		;
	dec		r17
	brne	delay650

rcall	OWReset

ldi		w1rdbuf,$CC
rcall	OWWriteByte

ldi		w1rdbuf,$BE
rcall	OWWriteByte

rcall	OWReadByte
mov		Command_0,w1rdbuf

rcall	OWReadByte
mov		Command_1,w1rdbuf

rcall	OWReadByte
;mov		Command_2,w1rdbuf

rcall	OWReadByte
;mov		Command_3,w1rdbuf

rcall	OWReadByte
;mov		Command_4,w1rdbuf

rcall	OWReadByte
;mov		Command_5,w1rdbuf

rcall	OWReadByte
;mov		Command_6,w1rdbuf

rcall	OWReadByte
;mov		Command_7,w1rdbuf

rcall	OWReadByte
;mov		Command_7,w1rdbuf

rcall	tCalk

rcall	SendLed
start1:
rjmp	start

;****************************************
;  
;   w1rdbuf
;****************************************
tCalk:
		ldi		w1cnt,4				;  (  16)
tCalkloop:
		ror		Command_1			;High   2
		ror		Command_0			;Low
		dec		w1cnt				;
		brne	tCalkloop			;  4 
;  
sbrs	Command_1,7
rjmp	NoZnak
mov		r1,Command_1
ldi		temp,$FF
mov		Command_1,temp
sub		Command_1,r1
inc		Command_1
NoZnak:
;****************************************
;   
		ldi		w1cnt,8				;   (8 bit)
		;clr		sc0			; 
		;clr		sc1			; 
		ClrSc
Rot21:	rol		Command_0		; 
		rol		sc0				;  0  1
		rol		sc1				;  2
		dec		w1cnt
		brne	Rot22
ret
;****************************************
Rot22:	mov		r17,sc0
		rcall	DecodeOneByte		; 0  1
		mov		sc0,r17
		mov		r17,sc1
		rcall	DecodeOneByte		;  2
		mov		sc1,r17
		rjmp	Rot21
;****************************************
;  
DecodeOneByte:
		ldi		r18,$03
		add		r18,r17
		sbrc	r18,3
		mov		r17,r18
		ldi		r18,$30
		add		r18,r17
		sbrc	r18,7
		mov		r17,r18
		ret
;****************************************
;mainLoop:
;rcall	OWReset
;rjmp	mainLoop
;*****************************************************
;   HT1611 Command_0 - Command_4 (40 )
;*****************************************************
SendLed:	cbi		PORTB,Dout		;Dout  "0"
		;ldi		Count,InChange
		ldi		SendCnt,40		; 40 
SendCicle:
	;	sbrc	Command_4,7		;  7     - 
		sbrc	sc4,7
		sbi		PORTB,Dout		;Dout  "1"
		cbi		PORTB,Clk		;
	ldi		SendDelReg,SendDel	;
Wait:							; 
	nop	nop	nop
	dec		SendDelReg
	brne	Wait				; 
	;		RolCmd
			RolSc
		sbi		PORTB,Clk		; 
		cbi		PORTB,Dout		;Dout  "0"
		dec		SendCnt			; 
		brne	SendCicle		; 
		ret
;*****************************************************
